import { PrismaClient } from '@prisma/client';
import Joi from 'joi';
import { AccessInfo } from '../auth';
import { BaseModel, BaseModelBrowseArgs } from '../model';
export declare class BaseService<T, Browse, Read, Edit, Add, Delete, Activate, Deactivate> {
    private readonly BASE_SERVICE_LOG;
    private readonly BASE_SERVICE_FILTER_ORG;
    private readonly entityName;
    readonly model: BaseModel<T, PrismaClient, PrismaClient, BaseModelBrowseArgs> & {
        instance: BaseModel<T, PrismaClient, PrismaClient, BaseModelBrowseArgs>;
    };
    readonly schemaBrowse: Joi.ObjectSchema;
    readonly schemaRead: Joi.ObjectSchema;
    readonly schemaEdit: Joi.ObjectSchema;
    readonly schemaAdd: Joi.ObjectSchema;
    readonly schemaDelete: Joi.ObjectSchema;
    readonly schemaActivate: Joi.ObjectSchema;
    readonly schemaDeactivate: Joi.ObjectSchema;
    constructor({ entityName, model, schemaBrowse, schemaRead, schemaEdit, schemaAdd, schemaDelete, schemaActivate, schemaDeactivate }: {
        entityName: any;
        model: any;
        schemaBrowse: any;
        schemaRead: any;
        schemaEdit: any;
        schemaAdd: any;
        schemaDelete: any;
        schemaActivate: any;
        schemaDeactivate: any;
    });
    protected filterOrganization(_params: Browse | Read | Edit | Delete | Activate | Deactivate, _accessInfo: AccessInfo): void;
    browse(params: Browse, accessInfo: AccessInfo): Promise<import("../model").BaseModelBrowseReturn<T>>;
    read(params: Read, accessInfo: AccessInfo): Promise<unknown>;
    edit(params: Edit, accessInfo: AccessInfo): Promise<unknown>;
    add(params: Add, accessInfo: AccessInfo): Promise<unknown>;
    delete(params: Delete, accessInfo: AccessInfo): Promise<unknown>;
    activate(params: Activate, accessInfo: AccessInfo): Promise<unknown>;
    deactivate(params: Deactivate, accessInfo: AccessInfo): Promise<unknown>;
}
